program Agenda;
uses UTApli, UTForm, UTBtn, UTLista, UTEdit;

const
  evSalir     = #01;
  evAgregar   = #03;
  evEliminar  = #04;

type

   TFormAgenda = object(TForm)
                  BtnSalir : TBtn;
                  LstNombre: TLista;
                  BtnAgrega: TBtn;
                  BtnElimin: TBtn;
                  Edit1 : TEdit;
                  procedure Iniciar (Ctrl : ControlPtr);
                  function ManEv (Tipo : TipoEv; Ev : char;var Resp : boolean):char;virtual;
                end;

 procedure TFormAgenda.Iniciar (Ctrl : ControlPtr);
 begin
 {crea el formulario}
   Largo (280);
   Alto (170);
   crear (20, 20, 'SoftLiven Agenda v0.1');

 {crea los controles del formulario}
   LstNombre.Alto (150);
   LstNombre.Largo (110);
   LstNombre.Crear (05,10, nil, ctrl);
   Edit1.Largo (120);
   Edit1.Crear (130, 15, ' ', Ctrl);
   BtnAgrega.Crear (130, 50, chr(1)+' Agregar  ', evAgregar, Ctrl);
   BtnElimin.Crear (130, 90, chr(2)+' Eliminar ', evEliminar, Ctrl);
   BtnSalir.Crear (130, 130, ' -> Salir  ', evSalir,Ctrl);
 {agrega los controles del formulario al bulce principal}

   Agregar (@BtnSalir);
   Agregar (@BtnElimin);
   Agregar (@BtnAgrega);
   Agregar (@Edit1);
   Agregar (@LstNombre);
 {inicia el bucle principal}
   while CaptEv <> #0 do
 end;

 function TFormAgenda.ManEv (Tipo : TipoEv; Ev : char;var Resp : boolean):char;
 begin
   inherited ManEv (Tipo, Ev, Resp);
   case Tipo of
     Objeto : case ev of
                evSalir : Destruir;
                evAgregar : begin
                              LstNombre.Agregar (Edit1.Entrada);
                              Edit1.Texto (' ');
                            end;

                evEliminar:with lstNombre do
                          begin
                            eliminar (ActualPtr);
                            Actualizar;
                           end;

              end;
   end;
 end;

var
  FormAgenda : TFormAgenda;
begin
  FormAgenda.Iniciar (@FormAgenda);
end.
