program InfConf;
uses UTApli, UTForm, UTBtn, UTEtiq, UTDlgs;
const
  evSalir = #01;
  evMouse = #02;
  evVideo = #03;
  evTecla = #04;
  evMemor = #05;

type
  TApli = object (TForm)
            destructor destruir;virtual;
            procedure Iniciar (Ctrl : ControlPtr);
            function ManEv (Tipo : TipoEv; Ev:char;var Resp:Boolean):char;virtual;
            procedure InfoMouse;
           private
             p : pointer;
          end;

  InfoMousePtr = ^TInfoMouse;
  TInfoMouse = object (TForm)
                 EtqVer, EtqTip : TEtiq;
                 Btn : TBtn;
                 procedure Iniciar (Ctrl : ControlPtr);
                 function ManEv (Tipo : TipoEv; Ev:char;var Resp:Boolean):char;virtual;
               end;

{procedimientos del objeto TApli}
 destructor TApli.destruir;
 begin
   inherited destruir;
   release (p);
 end;

 procedure TApli.Iniciar (Ctrl : ControlPtr);
 begin
   IniciarModoGrafico;
   Largo (350);
   Alto (200);
   Crear (150, 100, 'SofLiVen Informacion de configuracin');
   mark (p);
   Agregar (new (BtnPtr, crear(10,120,'Memoria',evMemor, ctrl)));
   Agregar (new (BtnPtr, crear(10,90,'Teclado', evTecla, ctrl)));
   Agregar (new (BtnPtr, crear(10,60,' Video ', evVideo, ctrl)));
   Agregar (new (BtnPtr, crear(10,30,' Mouse ', evMouse, ctrl)));
   Agregar (new (BtnPtr, Crear(140,170,'Salir',evSalir, Ctrl)));
   Agregar (new (EtiqPtr, crear(10,2,' -> Haga click en un opcin  ', Ctrl)));
   while CaptEv <> #0 do
 end;

 function TApli.ManEv (Tipo : TipoEv; Ev:char;var Resp:Boolean):char;
 begin
   Inherited ManEv (Tipo, Ev, Resp);
   case tipo of
    usuario : case Ev of
                cEsc : Destruir;
              end;

    objeto : case Ev of
               evSalir : Destruir;
               evMouse : InfoMouse;
             end;
   end;
 end;

 procedure TApli.InfoMouse;
 var
   FormInfoMouse : InfoMousePtr;
 begin
   FormInfoMouse := New (InfoMousePtr);
   FormInfoMouse^.Iniciar (FormInfoMouse);
   Dispose (FormInfoMouse)
 end;

{procedimientos del objeto TInfoMouse}
 procedure TInfoMouse.Iniciar (Ctrl : ControlPtr);
 var
  s1, s2, s3 : string;
  v1, v2, tp : byte;
 begin
   Largo (200);
   Alto (150);
   Crear (100, 250, 'Informacin del Mouse');
   Btn.crear(60, 120,'Aceptar', evSalir, Ctrl);
   Agregar (@Btn);
   asm
     mov ch,$00
     MOV AX,$24
     INT $33
     MOV v1,BH
     MOV v2,BL
     MOV tp,CH
   end;
   str (v1,s1);
   str (v2, s2);
   case tp of
    1 : s3 := 'ratn bus';
    2 : s3 := 'ratn serial';
    3 : s3 := 'ratn InPort';
    4 : s3 := 'ratn PS/2';
    5 : s3 := 'ratn HP';
   end;
   EtqVer.crear(2,10,'Versin: '+s1+'.'+s2, Ctrl);
   EtqTip.crear(2,50,'Tipo: '+s3, Ctrl);
   Agregar (@EtqVer);
   Agregar (@EtqTip);
   while CaptEv <> #0 do
 end;

 function TInfoMouse.ManEv (Tipo : TipoEv; Ev:char;var Resp:Boolean):char;
 begin
   Inherited ManEv (Tipo, Ev, Resp);
   case tipo of
      usuario : case ev of
                 cEsc : destruir;
                end;

      Objeto : case ev of
                 evSalir : destruir
               end;
   end
 end;

var
  Apli : TApli;
begin
  Apli.Iniciar (@Apli)
end.