unit Graf;
interface
const
  _640x480 = $12;
  _320x200 = $13;

  procedure IniModoGraf ( m : byte);
  procedure pPixel (x, y : word; color : byte);
  procedure cuadro (x1, y1, x2, y2, color: word);

var
 MaxX : word;
 MaxY : word;

implementation

 procedure iniModoGraf ( m : byte);
 begin
   asm
     MOV AH, $00
     MOV AL, M
     INT $10
   end;
   case m of
    _640x480 : MaxX := 640;
    _320x200 : MaxX := 320;
   end;
 end;

 procedure pPixel (x, y : word; color : byte);
 begin
   Mem [$A000:y*MaxX+x] := color
 end;

 procedure cuadro (x1, y1, x2, y2, color: word);
 var x, y : word;
 begin
   for y := y1 to y2 do
    for x := x1 to x2 do
     Mem [$A000:y*MaxX+x] := color
 end;
end.